void scribe(color c, String S) {fill(c); text(S,20,20); noFill();}
void scribe(String S) {fill(black); text(S,20,20); noFill();}
void scribe() {fill(black); text("("+mouseX+","+mouseY+")",mouseX,mouseY); noFill();}
void scribe(String S, int i) {fill(black); text(S,20,20+i*20); noFill();}
void scribe(String S, int i, color c) {fill(c); text(S,20,20+i*20); noFill();}
void mousePressed() { if (mouse().isInWindow()) clickPolygon(); else ; } 
String lm=""; //latest method 
int picX=0; // picture number for saving sequences of pictures of making movies
int picx=0; // picture number for loading sequences of pictures of making movies

void mouseDragged() {if(animate&&fourPoint) FourPointAnimationInit();}

void keyPressed() {  
  if (key==' ') showHelpText=!showHelpText ; 
  if (key=='-') {animate=!animate; tt=0; FourPointAnimationInit(); FPAi=0;} ;  
  if (key=='=') {showFrames=!showFrames; } ;  
  if (key=='[') {showKeys=!showKeys; } ;  
  if (key=='!') {showConstruction=!showConstruction; } ;  
  if (key=='?') {printIt=true;}  // toggle debug mode
  if (key=='/') {
    EDGE A=E(P[0],P[1]);  EDGE B=E(P[2],P[3]);  EDGE C=E(P[4],P[5]);    EDGE D=E(P[6],P[7]);
    EDGE Bp=retrofitBezier(A,B,C,D); EDGE Cp=retrofitBezier(D,C,B,A); 
    P[2].setTo(Bp.A); P[3].setTo(Bp.B); P[4].setTo(Cp.A); P[5].setTo(Cp.B); }

//  if (key=='a')  ; 
  if (key=='A') {if(fn<maxfn) {savePts("data/P"+Format0(fn,2)); saveTwists("data/T"+Format0(fn,2));} else {fn=maxfn; savePts("data/P"+Format0(fn,2)); saveTwists("data/T"+Format0(fn,2));maxfn++; saveP();};}; 
  if (key=='b') {showBezier=!showBezier; if(showBezier)  lm="B";} ;  
  if (key=='c') {showCatmull=!showCatmull; if(showCatmull) lm="C"; } ;  
  if (key=='d') { P[2].setTo(P[0]); twist[2]=twist[0]; P[3].setTo(P[1]); twist[3]=twist[1];  P[6].setTo(P[4]); twist[6]=twist[4]; P[7].setTo(P[5]); twist[7]=twist[5]; } ;  
  if (key=='e') {expo=!expo; if(expo) lm="E";}  // Exponential or linear spiral
  if (key=='f') {fourPoint=!fourPoint; lm="F"; } ;  
  if (key=='g') {loadP(); fn=(fn+1)%(maxfn+1); if(fn<maxfn) loadPts("P"+Format0(fn,2)); loadTwists("T"+Format0(fn,2)); if(animate&&fourPoint) FourPointAnimationInit();};
  if (key=='G') {loadP(); fn--; if(fn<0) fn=maxfn-1; } ;  
  if (key=='h') {showLinear=false; showCubic=false; showMid=false; showSpiral=false; expo=false; fit=false; showBezier=false; showCatmull=false;  fourPoint=false;};
  if (key=='H') {showLinear=true; showCubic=true; showMid=true; showSpiral=true; expo=true; fit=true; showBezier=true; showCatmull=true;  fourPoint=true;};
  if (key=='i') {fit=!fit; if(fit) lm="I";}  // Interpolating spiral
  if (key=='l') {showLinear=!showLinear; if(showLinear) lm="L";} ;  
  if (key=='m') {showMid=!showMid; if(showMid) lm="M";} ;  
  if (key=='P') {saveFrame("data/Pictures/f"+Format0(picX++,3)+".jpg"); } // saves graphic window as image to file
  if (key=='p') {loadedI=!loadedI; if(loadedI) I = loadImage("data/Pictures/f000.jpg"); } // load next image
//  if (key=='p') {I = loadImage("data/Pictures/f"+Format0(picx++,3)+".jpg");  loadedI=!loadedI;} // load next image
//if (key=='r')  ; 
  if (key=='s') {showSpiral=!showSpiral; if(showSpiral) lm="S";} ;  
//if (key=='t')  ; 
  if (key=='v') {showCubic=!showCubic; if(showCubic) lm="V";} ;  
  if ((key=='X')||(key=='x')) {String S="images/ex"+Format0(fn,2)+"/"+lm+"_####.tif"; saveFrame(S); };  
//if (key=='z')  ; 
  if (key=='0')  zeroTwists(); 
  if (key=='1')  unifyLengths(); 
  if(animate&&fourPoint) FourPointAnimationInit(); 
  };     

void showHelp() {
     image(me, width-me.width, 0); 
     fill(dred); 
     pushMatrix(); translate(20,20);
     text("Spine Animations with Steady Spiral Splines",0,0); translate(0,20);
     text("Jarek Rossignac",0,0); translate(0,20);
     text("May-June 2009",0,0); translate(0,20);
     fill(dgreen); 
     translate(0,20);
     text("First click in this window to activate it",0,0); translate(0,20);
     text("Press SPACE to show/hide this help text",0,0); translate(0,20);
     text("Click & drag to pick and adjust the endpoints of the four black control spines",0,0); translate(0,20);
     text("Use the mouse wheel to twist the last selected endpoint",0,0); translate(0,20);
     text("  or keep 'a' pressed, click near an endpoint, and drag around to twist it",0,0); translate(0,20);
     text("Press 'd' to set B=A and D=C (nice with 'b')",0,0); translate(0,20);
     text("Press '0' to zero twists, '1' to set lengths to average",0,0); translate(0,20);
     text("Press 'z, 'r', or 't' and click&drag to zoom, rotate,or  translate the canvas ",0,0); translate(0,20);
     text("Press 'g' to load the next example",0,0); translate(0,20);
     text("Show/hide '-':animation, '=':frames, '[':key spines, !:construction",0,0); translate(0,20);
     text("Toggles to show/hide various morphs:",0,0); translate(0,20);
     text("  l: linear interpolation of corresponding endpoints",0,0); translate(0,20);
     text("  v: vertex-interplating cubic paths for endpoints",0,0); translate(0,20);
     text("  m: midpoint-interplating cubic path (linear scale, linear twist)",0,0); translate(0,20);
     text("  s: steady spirals for consecutive edge-pairs (logarithmic scale, linear twist)",0,0); translate(0,20);
     text("  e: equi-tempered spirals for consecutive edge-pairs (linear scale, linear twist)",0,0); translate(0,20);
     text("  b: Bezier of steady spirals (not interpolating)",0,0); translate(0,20);
     text("  i: interpolation attempt by retrofitting the Bezier control spines",0,0); translate(0,20);
     text("  c: Catmul-Rom of spirals",0,0); translate(0,20);
     text("  f: Four-point subdivision of spirals",0,0); translate(0,20);
     text("  h/H: shortcuts to hide/show all spines",0,0); translate(0,20);
     translate(0,20);
     text("WHEN RUNNING PROCESSING LOCALLY (not as an applet through a web browser):",0,0); translate(0,20);
     text(" 'X' to snap a picture",0,0); translate(0,20);
     text(" 'P'/'p' to save/load a background image (for comparison)",0,0); translate(0,20);
     text(" 'G' to advance output file number and 'A' to save the current example",0,0); translate(0,20);
     popMatrix(); noFill();
     int mi=20; for(int i=0; i<=mi; i++) {fill(interColHBS(lred,float(i)/mi,dmagenta)); ellipse(width*(0.5+i)/(mi+1),height-30,15,15);} // draws color ramp dots

   }
     
