boolean loopIsClosed = true;
int n=8;                        // current number of points
pt [] P = new pt[1000];            // decalres an array of  points
float [] twist = new float [1000];  // decalres an array of twist angles for points
int p=0;                         // index to the currently selected vertex being dragged
void mouseWheel(int delta) {twist[p]+=0.01*delta; if(animate&&fourPoint) FourPointAnimationInit();} // executed when a mouse wheel is turned
int next(int j) {  if (j==n-1) {return (0);}  else {return(j+1);}  };  // next point in loop
int prev(int j) {  if (j==0) {return (n-1);}  else {return(j-1);}  };  // previous point in loop                                                     
void declarePoints() {for (int i=0; i<P.length; i++) P[i]=new pt();} // init the vertices to be on a circle
void resetPoints() {for (int i=0; i<n; i++) {P[i]=new pt(width/2,height/7.); P[i].rotateBy(2.*PI*i/n, screenCenter());}; } // init the points to be on a circle
void appendPoint(pt Q)  { P[n++].setTo(Q);  }; // add point at end of list
// ************************************** EDITING *********************************
void clickPolygon() {pickClosestPoint();}
void editPolygon() {dragPoint(); };
void pickClosestPoint(pt M) {if(mouseIsInWindow()) { p=0; for (int i=1; i<n; i++) if (M.disTo(P[i])<M.disTo(P[p])) p=i; };}
void pickClosestPoint() {pt M = mouse(); p=0; for (int i=1; i<n; i++) if (M.disTo(P[i])<M.disTo(P[p])) p=i;}
void dragPoint() { P[p].moveWithMouse(); P[p].clipToWindow(); }      // moves selected point (index p) by amount mouse moved recently
void twistPoint() { twist[p]+=a(Pmouse(),P[p],Mouse());  }      // moves selected point (index p) by amount mouse moved recently
void dragPoint(vec V) {P[p].translateBy(V);}
void deletePoint() { for (int i=p; i<n-1; i++) P[i].setTo(P[next(i)]); n--; p=prev(p);}
void translatePoints(vec V) {for (int i=0; i<n; i++) P[i].translateBy(V); };   
void scalePoints(float s) {for (int i=0; i<n; i++) P[i].translateTowards(s,screenCenter());};  
// ************************************** MOVING *********************************
void scaleBy(float s) {for (int i=0; i<n; i++) P[i].setTo(S(P[i],s,screenCenter()));};   
void translateBy(vec V) {for (int i=0; i<n; i++) P[i].translateBy(V); };   
void rotateBy(float aa) {for (int i=0; i<n; i++) P[i].rotateBy(aa,screenCenter());}; 
// ************************************** VIEWING *********************************
void showPoints() {for (int i=0; i<n; i++) P[i].show();}
void showPoints(int r) {for (int i=0; i<n; i++) P[i].show(r);}
void showTwists(int r) {for (int i=0; i<n; i++) arrow(P[i],r,V().makeRotatedBy(twist[i])); }
void drawPointIDs() {for (int i=0; i<n; i++) {vec V=P[i].makeVecToAverage(P[prev(i)],P[next(i)]); V.normalize(); V.scaleBy(-10); V.add(-3,5); P[i].showLabel(str(i),V); };}; 
void drawPolygon() {beginShape();  for (int i=0; i<n; i++) P[i].v(); endShape(CLOSE); }    
void drawPolygon(boolean closed) {beginShape();  for (int i=0; i<n; i++) P[i].v(); if(closed) endShape(CLOSE); else endShape();} 
void drawEdge(int i) {if((0<=i)&&(i<n)) P[i].to(P[next(i)]);}
// ************************************** ARCHIVAL *********************************
void savePts() {savePts("P");}
void savePts(String fn) { String [] inppts = new String [n+1];
    int s=0; inppts[s++]=str(n); for (int i=0; i<n; i++) {inppts[s++]=str(P[i].x)+","+str(P[i].y);};
    saveStrings(fn,inppts);  };
void loadPts() {loadPts("P");}
void loadPts(String fn) { String [] ss = loadStrings(fn);
    String subpts;
    int s=0; int comma; n = int(ss[s]);
    for(int i=0;i<n; i++) { comma=ss[++s].indexOf(',');
      P[i]=new pt (float(ss[s].substring(0, comma)), float(ss[s].substring(comma+1, ss[s].length()))); }; };

void saveTwists() {saveTwists("T");}
void saveTwists(String fn) { String [] inppts = new String [n+1];
    int s=0; inppts[s++]=str(n); for (int i=0; i<n; i++) {inppts[s++]=str(twist[i]);};
    saveStrings(fn,inppts);  };
void loadTwists() {loadTwists("T");}
void loadTwists(String fn) { String [] ss = loadStrings(fn);
    int s=0;  n = int(ss[s]);
    for(int i=0;i<n; i++) twist[i]=float(ss[++s]); };
//*************************************** ADJUSTING EDGES *************************
void zeroTwists() {for (int i=0; i<n; i++) twist[i]=0;} 
void unifyLengths() {
   float L=0; for (int i=0; i<n/2; i++) L+=d(P[2*i],P[2*i+1]); L*=2./n;
   for (int i=0; i<n/2; i++) {pt M=M(P[2*i],P[2*i+1]); vec V=U(V(P[2*i],P[2*i+1])); P[2*i].setTo(S(M,-L/2,V)); P[2*i+1].setTo(S(M,L/2,V)); }
   }
      
